/*
 *
 *     This file is part of the Squashtest platform.
 *     Copyright (C) 2017 Henix, henix.fr
 *
 *     See the NOTICE file distributed with this work for additional
 *     information regarding copyright ownership.
 *
 *     This is free software: you can redistribute it and/or modify
 *     it under the terms of the GNU Lesser General Public License as published by
 *     the Free Software Foundation, either version 3 of the License, or
 *     (at your option) any later version.
 *
 *     this software is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU Lesser General Public License for more details.
 *
 *     You should have received a copy of the GNU Lesser General Public License
 *     along with this software.  If not, see <http://www.gnu.org/licenses/>.
 */
package org.squashtest.tm.plugin.rest.validators;

import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Component;
import org.springframework.validation.Errors;
import org.springframework.validation.ValidationUtils;
import org.squashtest.tm.domain.bdd.ActionWord;
import org.squashtest.tm.domain.project.Project;
import org.squashtest.tm.plugin.rest.jackson.model.ProjectDto;
import org.squashtest.tm.plugin.rest.jackson.model.RestActionWordDto;
import org.squashtest.tm.service.internal.repository.ActionWordDao;
import org.squashtest.tm.service.internal.testcase.bdd.LibraryActionWordParser;

import javax.inject.Inject;

@Component
public class ActionWordPostValidator extends EntityValidator {

    private static final String ID = "id";
    private static final String PROJECT = "project";
    private static final String WORD = "word";
    private static final String PARAMETERS = "parameters";
    private static final String TEST_CASES = "testCases";

    private static final String CODE_DUPLICATE_WORD = "duplicate word";
    private static final String CODE_GENERATED_VALUE = "generated value";
    private static final String CODE_REQUIRED_ATTRIBUTE = "required attribute";
    private static final String CODE_INVALID_ATTRIBUTE = "invalid attribute";

    private static final String MESSAGE_CAN_NOT_BE_EMPTY = "This attribute cannot be empty.";
    private static final String MESSAGE_DUPLICATE_WORD = "An action word with the given word already exists.";
    private static final String MESSAGE_GENERATED_ATTRIBUTE =
            "This attribute is generated by database and should not be provided. " +
                    "If you want to update an existing action word, please do a patch request to the action word id.";
    private static final String MESSAGE_PROJECT_MANDATORY = "The project attribute is mandatory to post an action word.";
    private static final String MESSAGE_THE_ATTRIBUTE_CANNOT_BE_POSTED =
            "Only attributes belonging to the action word itself can be posted. " +
                    "The attribute %1$s cannot be posted. " +
                    "Use direct url to the %1$s instead.";

    @Inject
    private ActionWordDao actionWordDao;

    @Override
    public boolean supports(Class<?> clazz) {
        return RestActionWordDto.class.equals(clazz);
    }

    @Override
    public void validate(Object target, Errors errors) {
        RestActionWordDto post = (RestActionWordDto) target;
        checkActionWordId(errors, post.getId());
        checkWordAttribute(errors);
        checkDuplicateWord(errors, post);
        checkForbiddenPostAttributes(errors, post);
        checkProject(errors, post);
    }

    private void checkActionWordId(Errors errors, Long actionWordId) {
        if (actionWordId != null) {
            errors.rejectValue(
                    ID,
                    CODE_GENERATED_VALUE,
                    MESSAGE_GENERATED_ATTRIBUTE);
        }
    }

    private void checkWordAttribute(Errors errors) {
        ValidationUtils.rejectIfEmptyOrWhitespace(
                errors,
                WORD,
                CODE_REQUIRED_ATTRIBUTE,
                MESSAGE_CAN_NOT_BE_EMPTY);

    }

    private void checkDuplicateWord(Errors errors, RestActionWordDto post) {
        ProjectDto postedProject = post.getProject();
        String postedWord = post.getWord();
        if (postedProject != null && !StringUtils.isBlank(postedWord)) {
            LibraryActionWordParser parser = new LibraryActionWordParser();
            ActionWord postedActionWord = parser.createActionWordInLibrary(post.getWord().trim());
            String postedToken = postedActionWord.getToken();
            ActionWord retrievedActionWord =
                    actionWordDao.findByTokenInCurrentProject(postedToken, post.getProject().getId());
            if(retrievedActionWord != null && postedToken.equals(retrievedActionWord.getToken())) {
                errors.rejectValue(
                        WORD,
                        CODE_DUPLICATE_WORD,
                        MESSAGE_DUPLICATE_WORD
                );
            }
        }
    }

    private void checkForbiddenPostAttributes(Errors errors, RestActionWordDto post) {
        if(post.getParameters() != null) {
            errors.rejectValue(
                    PARAMETERS,
                    CODE_INVALID_ATTRIBUTE,
                    String.format(MESSAGE_THE_ATTRIBUTE_CANNOT_BE_POSTED, PARAMETERS));
        }
        if(post.getTestCases() != null) {
            errors.rejectValue(
                    TEST_CASES,
                    CODE_INVALID_ATTRIBUTE,
                    String.format(MESSAGE_THE_ATTRIBUTE_CANNOT_BE_POSTED, TEST_CASES));
        }
    }

    private void checkProject(Errors errors, RestActionWordDto post) {
        ProjectDto project = post.getProject();
        if (project == null) {
            errors.rejectValue(
                    PROJECT,
                    CODE_REQUIRED_ATTRIBUTE,
                    MESSAGE_PROJECT_MANDATORY
            );
        } else {
            checkEntityExist(errors, Project.class, project.getId());
        }
    }
}
